<id>
BoardPassword for YaBB 2.2.2
</id>

<version>
v1.8
</version>

<mod info>
This mod add password access for Boards.

For each Board Admin can:
 - Set password access

Zip Package included
- BoardPass_Y222.mod
- BoardPass_Y222_german.mod
 
Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
 
Admin/ManageBoards.pl (ASCII)
Admin/ModList.pl (ASCII)
Languages/English/Admin.lng (ASCII)
Languages/English/Error.lng (ASCII)
Languages/English/Main.lng (ASCII)
Sources/BoardIndex.pl (ASCII)
Sources/Display.pl (ASCII)
Sources/Load.pl (ASCII)
Sources/MessageIndex.pl (ASCII)
Sources/Profile.pl (ASCII)
Sources/Recent.pl (ASCII)
Sources/RSS.pl (ASCII)
Sources/Search.pl (ASCII)
Sources/Subs.pl (ASCII)
Sources/SubList.pl (ASCII)
Templates/default/BoardIndex.template (ASCII)
Templates/yabb21/BoardIndex.template (ASCII)
 
yabbfiles/Templates/Forum/default/locking.giflockopen.gif (Binary)
yabbfiles/Templates/Forum/default/lockopen.gif (Binary) 


Mod History:
Status BoardPassword V1.8 ( June 05th 2008 )
- Updated for YaBB 2.2.2
</mod info>

<author>
Boris Tjuvanov (MF-B), Jeffrey Man (Jet Li) and Detlef Pilzecker (deti)
</author>

<homepage>
http://yabb.xost.ru/ and http://www.yabbworld.com
</homepage>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
		$ann      = "";
		$rbin     = "";
		$zeroch   = "";
		$attch    = "";
		$showpriv = "";
		$brdpic   = "";
</search for>

<add after>
		$brdpasswr = "";
		$brdpassw = ${$uid.$editboards[$i]}{'brdpassw'};
		$brdpassw3 = "";
		$brdpassw2 = "";
		if ($brdpassw ne '') { $brdpassw2 = qq~$admin_txt{'900pt'}~; }
		if (${$uid.$editboards[$i]}{'brdpasswr'} == 1) { $brdpasswr   = qq~ checked="checked"~; }
</add after>

<search for>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'97'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left">$genselect $admin_txt{'98'}</td>
</search for>

<add after>
   </tr><tr>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'900pw'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="paswwr$i" value="1"$brdpasswr /> <input type="text" size="15" name="pasww$i" value="$brdfpassw3" /><br />
    $admin_txt{'900pf'}<br />
    <font color="red">$brdpassw2</font>
    <input type="hidden" name="brdpassw$i" value="$brdpassw" /></td>
</add after>

<search for>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}\n");
</search for>

<replace>
		$FORM{"pasww$i"} =~ s/ //g;
		if ($FORM{"pasww$i"} ne '') {
			if ($FORM{"pasww$i"} !~ /\A[\s0-9A-Za-z!@#$%\^&*\(\)_\+|`~\-=\\:;'",\.\/?\[\]\{\}]+\Z/) { &fatal_error("$register_txt{'240'} $register_txt{'36'} $register_txt{'241'}") }
			$encryptopass = &encode_password($FORM{"pasww$i"});
		} else {
			if ($FORM{"paswwr$i"}) { $encryptopass = $FORM{"brdpassw$i"}; } else { $encryptopass = "";}
		}
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}|$FORM{\"paswwr$i\"}|$encryptopass\n");
</replace>

<search for>
		for (my $cnt = 0; $cnt <= $#oldcontrols; $cnt++) {
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender) = split(/\|/, $oldcontrols[$cnt]);
			chomp $changedboard;
			if ($moveitem eq $oldboard) {
				$oldcontrols[$cnt] = "";
				push(@boardcontrol, qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender~);
			}
		}
</search for>

<replace>
		for (my $cnt = 0; $cnt <= $#oldcontrols; $cnt++) {
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender,$brdpasswr,$brdpassw) = split(/\|/, $oldcontrols[$cnt]);
			chomp $changedboard;
			if ($moveitem eq $oldboard) {
				$oldcontrols[$cnt] = "";
				push(@boardcontrol, qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender|$brdpasswr|$brdpassw~);
			}
		}
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$BoardPass = "BoardPassword|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a>), Jeffrey Man (<a href=\"http://www.yabbworld.com\" target=\"_blank\">Jet Li</a>) and Detlef Pilzecker (deti)|This mod allow set password access to specific Boards|1.8|June 05th 2008|";
	push (@installed_mods, "$BoardPass");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'showall' => 'Show "All" on page selectors and Topic Summary?',
</search for>

<add after>
'900p' => 'There is an invalid character in the Board Password field. Valid Characters are Letters(a-z), Numbers (0-9), and ( # + - . @ ^ _ )',
'900pw' => 'Enter Password to access this board',
'900pf' => 'Checking this option and enter password here for access this Board password required',
'900pt' => 'Password for this Board was set sucessfully.',
</add after>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
'invalid_key'	 		=> "Masterkey is invalid !<br />This should be a text string between 8 and 24 characters long !",
</search for>

<add after>
'wrong_pass' 			=> "Wrong password!",
</add after>

<edit file>
Languages/English/Main.lng
</edit file>

<search for>
'freespace' => 'Free Host space available:',
</search for>

<add after>
'900b' => 'Back',
'900w' => 'Submit',
'900pw' => 'Enter Password for',
'900pd' => 'Password Access Board',
'900pr' => 'Private',
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		if (${$uid.$curboard}{'lastposttime'} > $lastthreadtime && $lastposttime{$curboard} ne $boardindex_txt{'470'}) {
			$lsdatetime = $lastposttime{$curboard};
			$lsposter = ${$uid.$curboard}{'lastposter'};
			$lssub = ${$uid.$curboard}{'lastsubject'};
			$lspostid = ${$uid.$curboard}{'lastpostid'};
			$lsreply = ${$uid.$curboard}{'lastreply'};
			$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
			$lspostbd = $curboard;
		}
</search for>

<replace>
		if (${$uid.$curboard}{'lastposttime'} > $lastthreadtime && $lastposttime{$curboard} ne $boardindex_txt{'470'}) {
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!${$uid.$curboard}{'brdpasswr'}) {
				$lsdatetime     = $lastposttime{$curboard};
				$lsposter       = ${$uid.$curboard}{'lastposter'};
				$lssub          = ${$uid.$curboard}{'lastsubject'};
				$lspostid       = ${$uid.$curboard}{'lastpostid'};
				$lsreply        = ${$uid.$curboard}{'lastreply'};
				$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
				$lspostbd       = $curboard;
			} elsif ($yyCookies{$cookiename} eq $crypass || ($iamadmin || $iamgmod || $iammodhere)) {
				$lsdatetime     = $lastposttime{$curboard};
				$lsposter       = ${$uid.$curboard}{'lastposter'};
				$lssub          = ${$uid.$curboard}{'lastsubject'};
				$lspostid       = ${$uid.$curboard}{'lastpostid'};
				$lsreply        = ${$uid.$curboard}{'lastreply'};
				$lastthreadtime = ${$uid.$curboard}{'lastposttime'};
				$lspostbd       = $curboard;
			}
		}
</replace>

<search for>
				if (${$uid.$curboard}{'threadcount'} < 0)  { ${$uid.$curboard}{'threadcount'}  = 0; }
				if (${$uid.$curboard}{'messagecount'} < 0) { ${$uid.$curboard}{'messagecount'} = 0; }
</search for>

<add before>
				my $boardpwpic = "";
				if (${$uid.$curboard}{'brdpasswr'}){
					my $cookiename = "$cookiepassword$curboard$username";
					my $crypass = ${$uid.$curboard}{'brdpassw'};
					if (!$iamadmin && !$iamgmod && !$iammod && $yyCookies{$cookiename} ne $crypass) {
						$boardpwpic = qq~<img src="$defaultimagesdir/locking.gif" border="0" align="middle" alt="$maintxt{'900pd'}" />~;
						$lastpostlink = qq~$maintxt{'900pr'}~;
						$lasttopiclink = qq~~;
						$lastposter = qq~~;
						$templateblock = $boardblockpw;
					} else {
						$boardpwpic = qq~<img src="$defaultimagesdir/lockopen.gif" border="0" align="middle" alt="$maintxt{'900pd'}" />~;
					}
				}
</add before>

<search for>
				$templateblock =~ s/({|<)yabb boardname(}|>)/$boardname/g;
</search for>

<replace>
				$templateblock =~ s/({|<)yabb boardname(}|>)/$boardname $boardpwpic/g;
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		$showmodgroups =~ s/, \Z/)/;
	}
</search for>

<add after>
	if (${$uid.$currentboard}{'brdpasswr'}) {
		my $cookiename = "$cookiepassword$currentboard$username";
		my $crypass = ${$uid.$currentboard}{'brdpassw'};
		if (!$iamadmin && !$iamgmod && !$iammod && $yyCookies{$cookiename} ne $crypass) { &BoardPassw($currentboard,$viewnum); }
	}
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw) = split(/\|/, $boardline);
</replace>

<search for>
			'genderperms'  => $cntgenderperms,);
</search for>

<replace>
			'genderperms'  => $cntgenderperms,
			'brdpasswr'  => $brdpasswr,
			'brdpassw'  => $brdpassw,);
</replace>

<search for>
		if ($boardline ne "") {
			my (@oldmods, @newmods, $testmod);
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
		if ($boardline ne "") {
			my (@oldmods, @newmods, $testmod);
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $brdpasswr, $brdpassw) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw\n");
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$brdpasswr|$brdpassw\n");
</replace>

<search for>
		$yySetCookies3 = cookie(
			-name    => "$cookiesession_name",
			-value   => "$sessionval",
			-path    => "$pathval",
			-expires => "$expiration");
</search for>

<add after>
	my ($catid, $boardlist, @bdlist, $curboard);
	foreach $catid (@categoryorder) {
		unless( $catid ) { next; }
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		foreach $curboard (@bdlist) {
			chomp $curboard;
			my $cookiename = "$cookiepassword$curboard$username";
			if ($yyCookies{$cookiename}) {
				push @otherCookies, cookie(
					-name    =>   "$cookiename",
					-value   =>   "",
					-path    =>   "/",
					-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
					$yyCookies{$cookiename} = '';
			}
		}
	}
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	if ($showmodgroups ne "" && $showmods ne "") { $showmods .= qq~ - ~; }
</search for>

<add after>
	if (${$uid.$currentboard}{'brdpasswr'}){
		my $cookiename = "$cookiepassword$currentboard$username";
		my $crypass = ${$uid.$currentboard}{'brdpassw'};
		if (!$iamadmin && !$iamgmod && !$iammod && $yyCookies{$cookiename} ne $crypass) { &BoardPassw; }
	}
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next boardcheck; }
</search for>

<add after>
			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}
</add after>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
			if (!$iamadmin && $access ne "granted") { next; }

			$catname{$curboard} = $catname;
</search for>

<replace>
			if (!$iamadmin && $access ne "granted") { next; }

			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}

			$catname{$curboard} = $catname;
</replace>

<search for>
			if (!$iamadmin && $access ne "granted") { next; }

			$catid{$curboard} = $catid;
</search for>

<replace>
			if (!$iamadmin && $access ne "granted") { next; }

			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}

			$catid{$curboard} = $catid;
</replace>

<search for>
			if (!$iamadmin && $access ne "granted") { next; }

			$catid{$curboard} = $catid;
</search for>

<replace>
			if (!$iamadmin && $access ne "granted") { next; }

			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}

			$catid{$curboard} = $catid;
</replace>

<edit file>
Sources/RSS.pl
</edit file>

<search for>
	### Security check ###
	if (&AccessCheck($currentboard, '', $boardperms) ne 'granted') { &RSS_error('no_access'); }
	if ($annboard eq $board && !$iamadmin && !$iamgmod) { &RSS_error('no_access'); }
</search for>

<add after>
	if (${$uid.$currentboard}{'brdpasswr'}){ 
			my $cookiename = "$cookiepassword$currentboard$username"; 
			my $crypass = ${$uid.$currentboard}{'brdpassw'}; 
			if (!$iamadmin && !$iamgmod && !$iammod && $yyCookies{$cookiename} ne $crypass) { &RSS_error('no_access'); } 
	}
</add after>

<search for>
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne 'granted') { next; }
</search for>

<add after>
			if (${$uid.$curboard}{'brdpasswr'}){ 
				my $cookiename = "$cookiepassword$curboard$username"; 
				my $crypass = ${$uid.$curboard}{'brdpassw'}; 
				if (!$iamadmin && !$iamgmod && !$iammod && $yyCookies{$cookiename} ne $crypass) { next; } 
			}
</add after>

<edit file>
Sources/Search.pl
</edit file>

<search for>
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }

			# Checks to see if category is expanded or collapsed
</search for>

<replace>
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }

			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}

			# Checks to see if category is expanded or collapsed
</replace>

<search for>
		if (!$iamadmin && $access ne "granted") { next; }

		fopen(FILE, "$boardsdir/$curboard.txt") || next;
</search for>

<replace>
		if (!$iamadmin && $access ne "granted") { next; }

			if (${$uid.$curboard}{'brdpasswr'}) {
			my $bdmods = ${$uid.$curboard}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$curboard}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$curboard$username";
			my $crypass = ${$uid.$curboard}{'brdpassw'};
			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}

		fopen(FILE, "$boardsdir/$curboard.txt") || next;
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3) {
</search for>

<replace>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3 || scalar @otherCookies) {
</replace>

<search for>
				-cookie   => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
</search for>

<replace>
				-cookie   => [$yySetCookies1, $yySetCookies2, $yySetCookies3, @otherCookies],
</replace>

<search for>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3) {
</search for>

<replace>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3 || scalar @otherCookies) {
</replace>

<search for>
				-cookie   => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
</search for>

<replace>
				-cookie   => [$yySetCookies1, $yySetCookies2, $yySetCookies3, @otherCookies],
</replace>

<search for>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3) {
</search for>

<replace>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3 || scalar @otherCookies) {
</replace>

<search for>
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
</search for>

<replace>
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3, @otherCookies],
</replace>

<search for>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3) {
</search for>

<replace>
		if ($yySetCookies1 || $yySetCookies2 || $yySetCookies3 || scalar @otherCookies) {
</replace>

<search for>
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3],
</search for>

<replace>
				-cookie  => [$yySetCookies1, $yySetCookies2, $yySetCookies3, @otherCookies],
</replace>

<search for>
		foreach $board (@bdlist) {
			($boardname, $boardperms, $boardview) = split(/\|/, $board{"$board"});
			&ToChars($boardname);
			my $access = &AccessCheck($board, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
</search for>

<add after>
			if (${$uid.$board}{'brdpasswr'}) {
			my $bdmods = ${$uid.$board}{'mods'};
			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$board}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$board$username";
			my $crypass = ${$uid.$board}{'brdpassw'};

			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}
</add after>

<search for>
			my $access = &AccessCheck($board, '', $boardperms);
			if (!$iamadmin && $access ne "granted") { next; }
</search for>

<add after>
			if (${$uid.$board}{'brdpasswr'}) {
			my $bdmods = ${$uid.$board}{'mods'};

			$bdmods =~ s/\, /\,/g;
			$bdmods =~ s/\ /\,/g;
			my %moderators = ();
			my $pswiammod = 0;
			foreach my $curuser (split(/\,/, $bdmods)) {
				if ($username eq $curuser) { $pswiammod = 1; }
			}
			my $bdmodgroups = ${$uid.$board}{'modgroups'};
			$bdmodgroups =~ s/\, /\,/g;
			my %moderatorgroups = ();
			foreach my $curgroup (split(/\,/, $bdmodgroups)) {
				if (${$uid.$username}{'position'} eq $curgroup) { $pswiammod = 1; }
				foreach my $memberaddgroups (split(/\, /, ${$uid.$username}{'addgroups'})) {
					chomp $memberaddgroups;
					if ($memberaddgroups eq $curgroup) { $pswiammod = 1; last; }
				}
			}
			my $cookiename = "$cookiepassword$board$username";
			my $crypass = ${$uid.$board}{'brdpassw'};

			if (!$iamadmin && !$iamgmod && !$pswiammod && $yyCookies{$cookiename} ne $crypass) { next; }
			}
</add after>

<search for>
1;
</search for>

<add before>
sub BoardPassw {
	#my ($currentboard,$viewnum) = @_;
	$yymain .= qq~
<table border="0" width="80%" cellspacing="1" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td class="titlebg"><img align="absmiddle" src="$defaultimagesdir/locking.gif" alt="" border="0" /> <b>$maintxt{'900pw'}: $boardname</b></td>
  </tr><tr>
    <td class="windowbg" align="center">
    <br />
      <form action="$scripturl?action=checkboardpw" method="POST">
        <input type="hidden" name="pswviewnum" value="$viewnum" />
        <input type="hidden" name="pswcurboard" value="$currentboard" />
        <input type="password" name="boardpw" value="" size="25"> <input type="submit" value="$maintxt{'900w'}">
      </form>
    <br />
    <br />
    </td>
  </tr>
</table>
<br />
<p align="center"><a href="javascript:history.go(-1)">$maintxt{'900b'}</a></p>
~;
	&template;
	exit;
}

sub BoardPasswCheck {

	my $returnnum = $FORM{'pswviewnum'};
	my $returnboard = $FORM{'pswcurboard'};
	my $spass = ${$uid.$returnboard}{'brdpassw'};
	my $cryptpass = &encode_password("$FORM{'boardpw'}");

	if ($spass ne $cryptpass) { &fatal_error('wrong_pass'); }
	$ck{'len'} = 'Sunday, 17-Jan-2030 00:00:00 GMT';
	my $cookiename = "$cookiepassword$returnboard$username";
	push @otherCookies, cookie(
				-name    =>   "$cookiename",
				-value   =>   "$cryptpass",
				-path    =>   "/",
				-expires =>   "$ck{'len'}");
	&WriteLog;
	undef $FORM{'boardpw'};
	if ($returnnum ne '') { 
		$yySetLocation = qq~$scripturl?num=$returnnum~;
	} else {
		$yySetLocation = qq~$scripturl?board=$returnboard~;
	}
	&redirectexit;
}
</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'boardnotify3',"Notify.pl&BoardNotify2",
</search for>

<add after>
'checkboardpw',"Subs.pl&BoardPasswCheck",
</add after>

<edit file>
Templates/default/BoardIndex.template
</edit file>

<search for>
$boardblock = qq~
</search for>

<add before>
$boardblockpw = qq~
<tr>
	<td class="windowbg" width="6%" align="center" valign="middle">
		<a href="{yabb boardurl}">{yabb boardpic}</a>
	</td>
	<td class="windowbg" width="54%" align="left" valign="middle">
		{yabb new} <a name="{yabb boardanchor}" href="{yabb boardurl}"><b>{yabb boardname}</b></a><br />
		{yabb boarddesc}<br />
		<span class="small"><i>{yabb moderators}</i></span>
	</td>
	<td class="windowbg2" valign="middle" align="center" width="24%">
	{yabb lastpostlink}<br />
	</td>
	<td class="windowbg" valign="middle" align="center" width="8%">{yabb threadcount}</td>
	<td class="windowbg" valign="middle" align="center" width="8%">{yabb messagecount}</td>
</tr>
~;

</add before>

<edit file>
Templates/yabb21/BoardIndex.template
</edit file>

<search for>
$boardblock = qq~
</search for>

<add before>
$boardblockpw = qq~
<tr>
	<td class="windowbg" width="5%" align="center" valign="top"><yabb new></td>
	<td class="windowbg2" width="55%" align="left"><a name="<yabb boardanchor>" href="<yabb boardurl>"><yabb boardpic><b><yabb boardname></b></a><br /><yabb boarddesc><br /><br /><span class="small"><i><yabb moderators></i></span></td>
	<td class="windowbg" valign="middle" align="center" width="24%">
	<yabb lastpostlink>
	</td>
	<td class="windowbg2" valign="middle" align="center" width="8%"><yabb threadcount></td>
	<td class="windowbg2" valign="middle" align="center" width="8%"><yabb messagecount></td>
</tr>
~;
</add before>